unit Demande;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Buttons;

type
  TDemande = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
    function DemandeDialog(Msg,Title:String;DlgType:TMsgDlgType;Buttons:TMsgDlgButtons):TForm;
  public
    { Public declarations }
    Msg,Title:String;
    DlgType:TMsgDlgType;
    Buttons:TMsgDlgButtons;
  public
    function Execute:Integer;
    function ShowModal:Integer;
  published
    { Published declarations }
  end;

procedure Register;

implementation

function TDemande.DemandeDialog(Msg,Title:String;DlgType:TMsgDlgType;Buttons:TMsgDlgButtons):TForm;
var
    Count,Index,i2:Integer;
    Form:TForm;
    i1:TMsgDlgBtn;
    Bit:array[0..100] of TBitBtn;
    Mega:array[0..1000] of char;
    Current1:String;
begin
    Count:=0;
    Form:=CreateMessageDialog(Msg,DlgType,Buttons);
    Form.BorderStyle:= bsSingle;
    Form.BorderIcons:=Form.BorderIcons -[biMaximize];
    if Title='' then Title:='Information';
    Form.Caption:=Title;
    for i1:= Low(TMsgDlgBtn) to High(TMsgDlgBtn) do
    begin
      if i1 in Buttons then Count:=Count+1;
    end;
    if Count<=0 then
    begin
        Result:=Form;
        Exit;
    end;
    Index:=Form.ControlCount;
    for i2:=Index downto Index-Count+1 do
    begin
        Bit[i2-Index]:=TBitBtn.Create(Self);
        with Bit[i2-Index] do
        begin
            Caption:='Caption';
            Left:=Form.Controls[i2-1].Left;
            Top:=Form.Controls[i2-1].Top;
            Width:=Form.Controls[i2-1].Width;
            Height:=Form.Controls[i2-1].Height+3;
        end;
        Form.Controls[i2-1].GetTextBuf(Mega,100);
        Current1:=Mega;
        if Current1='OK' then
        begin
            Bit[i2-Index].Kind:= bkOK;
            Bit[i2-Index].Caption:='Ok';
        end;
        if Current1='&Yes' then
        begin
            Bit[i2-Index].Kind:= bkYes;
            Bit[i2-Index].Caption:= '&Oui';
        end;
        if Current1='&No' then
        begin
            Bit[i2-Index].Kind:= bkNo;
            Bit[i2-Index].Caption:= '&Non';
        end;
        if Current1='Cancel' then
        begin
            Bit[i2-Index].Kind:= bkCancel;
            Bit[i2-Index].Caption:= 'Arrter';
        end;
        if Current1='&Help' then
        begin
            Bit[i2-Index].Kind:= bkHelp;
            Bit[i2-Index].Caption:= '&Aide';
        end;
        if Current1='&Abort' then
        begin
            Bit[i2-Index].Kind:= bkAbort;
            Bit[i2-Index].Caption:= '&Stop';
        end;
        if Current1='&Retry' then
        begin
            Bit[i2-Index].Kind:= bkRetry;
            Bit[i2-Index].Caption:= '&Encore';
        end;
        if Current1='&Ignore' then
        begin
            Bit[i2-Index].Kind:= bkIgnore;
            Bit[i2-Index].Caption:= '&Ignorer';
        end;
        if Current1='&All' then
        begin
            Bit[i2-Index].Kind:= bkAll;
            Bit[i2-Index].Caption:= '&Tous';
        end;
        Form.Controls[i2-1].Hide;
    end;
    for i2:=Index downto Index-Count+1 do
    begin
        Form.InsertControl(Bit[i2-Index]);
        Bit[i2-Index].Cursor:= crHandPoint;
    end;
    Result:=Form;
end;
function TDemande.Execute:Integer;
var
    Dialog:TForm;
begin
    if Title='' then Title:='Information';
    Dialog:=DemandeDialog(Msg,Title,DlgType,Buttons);
    Dialog.Icon:=Application.Icon;
    Result:=Dialog.ShowModal;
end;
function TDemande.ShowModal:Integer;
var
    But1:TMsgDlgButtons;
    Type1:TMsgDlgType;
    Dialog:TForm;
begin
    Type1:=mtInformation;
    But1:=[mbOK];
    if Title='' then Title:='Information';
    Dialog:=DemandeDialog(Msg,Title,Type1,But1);
    Dialog.Icon:=Application.Icon;
    Result:=Dialog.ShowModal;
end;


procedure Register;
begin
  RegisterComponents('MyControl1', [TDemande]);
end;

end.
 