unit UBitrate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TMyUBitrate = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    Panel4: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    DoApply:Boolean;
  end;

var
  MyUBitrate: TMyUBitrate;

implementation

uses USelector2;

{$R *.DFM}

procedure TMyUBitrate.FormShow(Sender: TObject);
begin
  Panel3.Caption:='';
  Edit1.Text:='';
  Edit1.SetFocus;
  DoApply:=False;
end;

procedure TMyUBitrate.Edit1Change(Sender: TObject);
var
  ASize1,ASize2:Integer;
begin
  ASize1:=StrToIntDef(Edit1.Text,0);
  ASize2:=0;
  case MyUSelector2.ComboBox7.ItemIndex of
    0:ASize2:=64;
    1,2:ASize2:=128;
    3,4:ASize2:=112;
    5,6:ASize2:=96;
  end;
  if MyUSelector2.ATimeLength=0 then begin
    Panel3.Caption:='0';
    Exit;
  end;
  Panel3.Caption:=IntToStr( ((ASize1*8*1024) div MyUSelector2.ATimeLength)-ASize2);
end;

procedure TMyUBitrate.BitBtn1Click(Sender: TObject);
begin
  DoApply:=True;
  Close;
end;

end.
 