{
   GetOption1=Mode, 0=Standard,1=Expert
   GetOption2=Language,0=English,1=French
   GetOption3=CDSize,0=650,1=700
   GetOption4=Erase Temp File,0=Yes,1=No
   GetOption5=ShutDown,0=Non Selectionne,1=Selectionne
   GetOption6=Automatic AVi Cutting,0=No,1=Yes
   GetOption7=Erase VOB file,0=no,1=Yes
   GetOption8=Codec, 0=3.22,1=4.0
}


unit UFonction;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons,ShellApi,Hour,Full,MySource;

type
  TTypeAuto=record
    Low,Fast:Boolean;
  end;
  TShellReturn=record
    Shell:TShellExecuteInfo;
    Work:Boolean;
  end;
  TShutDown=record
    Encode,Batch,Command:Integer;
  end;

function MyShellExecute3(FProgram,FCommand:String):TShellReturn;
procedure MyShellExecute2(FProgramm,FCommand:String);
function GetPath:String;
procedure Wait(FTimer:THour;FInterval:Integer);
function GetOption1:Integer;
function GetOption2:Integer;
function GetOption3:Integer;
function GetOption4:Integer;
function GetOption5:TShutDown;
function GetOption6:Integer;
function GetOption7:Integer;
function GetOption8:Integer;
procedure SetOptionFile;
procedure SetOption1(FInteger:Integer);
procedure SetOption2(FInteger:Integer);
procedure SetOption3(FInteger:Integer);
procedure SetOption4(FInteger:Integer);
procedure SetOption5(FShutDown:TShutDown);
procedure SetOption6(FInteger:Integer);
procedure SetOption7(FInteger:Integer);
procedure SetOption8(FInteger:Integer);
procedure TestSpeedFile;
procedure SetSpeedFile(FString:String);
function GetSpeedFile:String;
function AssignSlash(FString:String):String;
function GetDivxAuto(FKey,FQuality,FBitrate:Integer;FType:String='L'):String;
function DoTestPath:Boolean;


implementation

function MyShellExecute3(FProgram,FCommand:String):TShellReturn;
var
  exInfo:TShellExecuteInfo;
  exitCode:DWORD;
begin
  FillChar(exInfo,SizeOf(exInfo),0);
  with exInfo do begin
    cbSize:=SizeOf(exInfo);
    fMask:=SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_DDEWAIT;
    Wnd:=Application.Handle;
    lpVerb:='OPEN';
    lpFile:=PChar(FProgram);
    nShow:=SW_SHOWNORMAL;
    lpParameters:=PChar(FCommand);
  end;
  if ShellExecuteEx(@exInfo) then begin
    Result.Shell:=exInfo;
    Result.Work:=True;
  end
  else begin
    Result.Work:=False;
  end;
end;


function GetPath:String;
begin
//  Result:='c:\neodivx';
  Result:=ExtractFilePath(Application.ExeName);
end;

procedure MyShellExecute2(FProgramm,FCommand:String);
begin
  ShellExecute(0,'OPEN',PChar(FProgramm),PChar(FCommand),'',SW_SHOW);
end;

procedure Wait(FTimer:THour;FInterval:Integer);
begin
  FTimer.OnF:=True;
  while FTimer.Elapse<FInterval do begin
  end;
end;

function GetOption1:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[0]);
    Free;
  end;
end;

function GetOption2:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[1]);
    Free;
  end;
end;

function GetOption3:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[2]);
    Free;
  end;
end;

function GetOption4:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[3]);
    Free;
  end;
end;

function GetOption5:TShutDown;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result.Encode:=StrToInt(Strings[4]);
    Result.Batch:=StrToInt(Strings[5]);
    Result.Command:=StrToInt(Strings[6]);
    Free;
  end;
end;

function GetOption6:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[7]);
    Free;
  end;
end;


function GetOption7:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[8]);
    Free;
  end;
end;

function GetOption8:Integer;
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
    Result:=StrToInt(Strings[9]);
    Free;
  end;
end;

procedure SetOptionFile;
var
  Full1:TStringList;
begin
  Full1:=TStringList.Create;
  if not FileExists(SlashSep(GetPath,'OPTION.NEO')) then begin
    Full1.Clear;
    Full1.Add('0');
    Full1.Add('0');
    Full1.Add('0');
    Full1.Add('1');
    //ShutDowning...
    Full1.Add('0');
    Full1.Add('0');
    Full1.Add('0');
    // End ShutDowning...
    Full1.Add('1'); //Cut Directly...
    // erase vob...
    Full1.Add('0');
    // Codec
    Full1.Add('0');
    Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  end;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  if Full1.Count<>10 then begin
    Full1.Clear;
    Full1.Add('0');
    Full1.Add('0');
    Full1.Add('0');
    Full1.Add('1');
    //ShutDowning...
    Full1.Add('0');
    Full1.Add('0');
    Full1.Add('0');
    // End ShutDowning...
    Full1.Add('1'); // cut directly...
    // Cut Vob ?
    Full1.Add('0'); //no
    // Codec
    Full1.Add('0');
    Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  end;
  Full1.Free;
end;

procedure SetOption1(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[0]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption2(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[1]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption3(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[2]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption4(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[3]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption5(FShutDown:TShutDown);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[4]:=IntToStr(FShutDown.Encode);
  Full1.Strings[5]:=IntToStr(FShutDown.Batch);
  Full1.Strings[6]:=IntToStr(FShutDown.Command);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption6(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[7]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption7(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[8]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;

procedure SetOption8(FInteger:Integer);
var
  Full1:TStringList;
begin
  SetOptionFile;
  Full1:=TStringList.Create;
  Full1.LoadFromFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Strings[9]:=IntToStr(FInteger);
  Full1.SaveToFile(SlashSep(GetPath,'OPTION.NEO'));
  Full1.Free;
end;


procedure TestSpeedFile;
var
  Full1:TStringList;
begin
  Full1:=TStringList.Create;
  with Full1 do begin
    if not FileExists(SlashSep(GetPath,'TEST.NEO')) then begin
      Clear;
      Add('-r1');
      SaveToFile(SlashSep(GetPath,'TEST.NEO'));
    end;
  end;
  Full1.Free;
end;

procedure SetSpeedFile(FString:String);
var
  Full1:TStringList;
begin
  TestSpeedFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    Clear;
    Add(FString);
    SaveToFile(SlashSep(GetPath,'TEST.NEO'));
  end;
  Full1.Free;
end;

function GetSpeedFile:String;
var
  Full1:TStringList;
begin
  TestSpeedFile;
  Full1:=TStringList.Create;
  with Full1 do begin
    LoadFromFile(SlashSep(GetPath,'TEST.NEO'));
    Result:=Strings[0];
  end;
  Full1.Free;
end;


function AssignSlash(FString:String):String;
var
  i1:Integer;
  FType:String;
begin
  FType:='';
  for i1:=1 to Length(FString) do begin
    FType:=FType+Copy(FString,i1,1);
    if Copy(FString,i1,1)='\' then FType:=FType+'\';
  end;
  Result:=FType;
end;

function GetDivxAuto(FKey,FQuality,FBitrate:Integer;FType:String):String;
var
  ALine1:String;
  FBeta:Integer;
begin
//  ALine1:=Format('WI00:ICCompressorChoose "CB00:DivX Codec 4.0 Beta" BT04: WI01: ED00:%d ED06:9999 "CB01:2-pass, first pass" BT00: WI00: BT02: QU00:',
//                 [FBitrate{,FKey}]);
//  Result:=ALine1;

  // This is for the 3.11 codec...
  FBeta:=GetOption8;
  if FBeta=0 then begin
    if FType='L' then begin
      ALine1:=Format('WI00:ICCompressorChoose "CB00:DivX ;-) MPEG-4 Low-Motion" BT04: WI01: ED00:%d SB00:%d SB01:%d BT05: WI00: BT02: QU00:',
                      [FKey,FQuality,FBitrate]);

    end
    else begin
      ALine1:=Format('WI00:ICCompressorChoose "CB00:DivX ;-) MPEG-4 Fast-Motion" BT04: WI01: ED00:%d SB00:%d SB01:%d BT05: WI00: BT02: QU00:',
                      [FKey,FQuality,FBitrate]);
    end;
  end;

  //This is for the Divx Codec 4.0 Beta.
  if FBeta=1 then begin
    ALine1:=Format('WI00:ICCompressorChoose "CB00:DivX Codec 4.0 Beta" BT04: WI01: ED00:%d ED06:%d'+{"CB01:2-pass, first pass"}' BT00: WI00: BT02: QU00:',
                    [FBitrate,FKey]);
  end;
  Result:=ALine1;
end;

function DoTestPath:Boolean;
var
  ALine1:String;
begin
  ALine1:=MyUpper(ExtractFilePath(Application.ExeName));
  if (ALine1<>'C:\NEODIVX\') and
     (ALine1<>'C:\NEODIVX') then begin
    Result:=False;
    Exit;
  end;
  Result:=True;
end;




end.
