unit UMakeLst;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Demande,MySource,UFonction;

type
  TMyUMakeLst = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    OpenDialog1: TOpenDialog;
    Demande1: TDemande;
    SaveDialog1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Feed;
  end;

var
  MyUMakeLst: TMyUMakeLst;

implementation

{$R *.DFM}

procedure TMyUMakeLst.FormShow(Sender: TObject);
begin
  Feed;
  ListBox1.Items.Clear;
end;

procedure TMyUMakeLst.BitBtn1Click(Sender: TObject);
var
  i1:Integer;
begin
  if not OpenDialog1.Execute then Exit;
  for i1:=0 to ListBox1.Items.Count-1 do begin
    if MyUpper(ListBox1.Items.Strings[i1])=
       MyUpper(OpenDialog1.FileName) then begin
      Exit;
    end;
  end;
  ListBox1.Items.Add(OpenDialog1.FileName);
end;

procedure TMyUMakeLst.BitBtn3Click(Sender: TObject);
begin
  if ListBox1.Items.Count<>0 then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Are you sure to clear the actuel List ?'
      else Msg:='Etes-vous sur de vouloir vider la liste actuelle ?';
      Buttons:=[mbYes,mbNo];
      if Execute=mrNo then Exit;
    end;
  end;
  ListBox1.Items.Clear;
end;

procedure TMyUMakeLst.BitBtn2Click(Sender: TObject);
var
  AString:String;
begin
  if not SaveDialog1.Execute then Exit;
  AString:=SaveDialog1.FileName;
  AString:=ChangeFileExt(AString,'.LST');
  ListBox1.Items.SaveToFile(AString);
  Close;
end;

procedure TMyUMakeLst.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To Create a LST File';
      BitBtn1.Caption:='Add VOB';
      BitBtn2.Caption:='Save';
      BitBtn3.Caption:='Clear List';
      BitBtn4.Caption:='Cancel';
    end;
    1:begin
      Caption:='Pour crer un fichier LST';
      BitBtn1.Caption:='Ajouter VOB';
      BitBtn2.Caption:='Sauver';
      BitBtn3.Caption:='Vider Liste';
      BitBtn4.Caption:='Arrter';
    end;
  end;
end;

end.
