unit UMultipler;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Demande, StdCtrls, Buttons, ExtCtrls, Full, FolderBrowse,FileCtrl,MySource,
  ShellApi,UFonction, Hour;

type
  TMyUMultipler = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    Panel4: TPanel;
    Edit2: TEdit;
    Panel5: TPanel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Demande1: TDemande;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Full1: TFull;
    Panel6: TPanel;
    SpeedButton3: TSpeedButton;
    Panel7: TPanel;
    Edit3: TEdit;
    FolderBrowse1: TFolderBrowse;
    Hour1: THour;
    Panel8: TPanel;
    Panel9: TPanel;
    ComboBox7: TComboBox;
    procedure BitBtn5Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function AssignSlash(FString:String):String;
    procedure MyCommande(FBeta1,FBeta2,FBeta3:String;FSon:Integer);
    procedure AddToCommande(FFull:TFull;FBeta1,FBeta2,FBeta3:String);
    procedure Feed;
  end;

var
  MyUMultipler: TMyUMultipler;

implementation

{$R *.DFM}

procedure TMyUMultipler.BitBtn5Click(Sender: TObject);
begin
  if not FileExists(Edit1.Text) then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Please select the video file before processing...'
      else Msg:='SVP, Selectionnez le fichier vido avant de continuer...';
      ShowModal;
      Exit;
    end;
  end;
  if not FileExists(Edit2.Text) then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Please select the audio file before processing...'
      else Msg:='SVP, Selectionnez le fichier audio avant de continuer...';
      ShowModal;
      Exit;
    end;
  end;
  if not DirectoryExists(Edit3.Text) then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Please select the output folder before processing...'
      else Msg:='SVP, Selectionnez le rpertoire de sortie avant de continuer...';
      ShowModal;
      Exit;
    end;
  end;
  MyCommande(Edit1.Text,Edit2.Text,Edit3.Text,ComboBox7.ItemIndex);
  Close;
end;

procedure TMyUMultipler.MyCommande(FBeta1,FBeta2,FBeta3:String;FSon:Integer);
var
  FString1:String;
  FString2:String;
  FString3:String;
begin
  Full1.Clear;
  Full1.Add(Format('VirtualDub.Open("%s",1,0);',[AssignSlash(FBeta1)]));
  Full1.Add(Format('VirtualDub.audio.SetSource("%s");',[AssignSlash(FBeta2)]));
  Full1.Add('VirtualDub.video.SetMode(0);');
  Full1.Add('VirtualDub.audio.SetMode(1);');
  Full1.Add('VirtualDub.audio.SetClipMode(1,0);');
  case FSon of
    0:begin
      Full1.Add('VirtualDub.audio.SetConversion(44100,0,0,0,1);');
      Full1.Add('VirtualDub.audio.SetCompression(353,44100,2,16,8010,372,10,"AAgAAAEAdAEAAAE=");');
    end;
    1:begin
      Full1.Add('VirtualDub.audio.SetCompression(85,48000,2,0,16000,1,12,"AQACAAAAgAEBAHEF");');
    end;
    2:begin
      Full1.Add('VirtualDub.audio.SetConversion(44100,0,0,0,1);');
      Full1.Add('VirtualDub.audio.SetCompression(85,44100,2,0,16000,1,12,"AQACAAAAoQEBAHEF");');
    end;
    3:begin
      Full1.Add('VirtualDub.audio.SetCompression(85,48000,2,0,14000,1,12,"AQACAAAAUAEBAHEF");');
    end;
    4:begin
      Full1.Add('VirtualDub.audio.SetConversion(44100,0,0,0,1);');
      Full1.Add('VirtualDub.audio.SetCompression(85,44100,2,0,14000,1,12,"AQACAAAAbQEBAHEF");');
    end;
    5:begin
      Full1.Add('VirtualDub.audio.SetCompression(85,48000,2,0,12000,1,12,"AQACAAAAIAEBAHEF");');
    end;
    6:begin
      Full1.Add('VirtualDub.audio.SetConversion(44100,0,0,0,1);');
      Full1.Add('VirtualDub.audio.SetCompression(85,44100,2,0,12000,1,12,"AQACAAAAOQEBAHEF");');
    end;
  end;

  Full1.Add(Format('VirtualDub.SaveAVI("%s");',[AssignSlash(SlashSep(FBeta3,'Movie0.avi'))]));
  Full1.Add('VirtualDub.Close();');
  Full1.SaveToFile(SlashSep(ExtractFilePath(Application.ExeName),'syliascript.syl'));

  Full1.Clear;
  Full1.Add(Format('VirtualDub.Open("%s",1,0);',[AssignSlash(SlashSep(FBeta3,'Movie0.avi'))]));
  Full1.Add('VirtualDub.audio.SetSource(1);');
  Full1.Add('VirtualDub.audio.SetMode(0);');
  Full1.Add('VirtualDub.audio.SetClipMode(1,1);');
  Full1.Add('VirtualDub.video.SetMode(0);');
  Full1.Add('VirtualDub.video.SetFrameRate(-1,1);');
  Full1.Add(Format('VirtualDub.SaveAVI("%s");',[AssignSlash(SlashSep(FBeta3,'FILM.AVI'))]));
  Full1.Add('VirtualDub.Close();');
  Full1.SaveToFile(SlashSep(ExtractFilePath(Application.ExeName),'syliascript2.syl'));

  FString2:=SlashSep(ExtractFilePath(Application.ExeName),'VirtualDub.exe');
  FString3:=SlashSep(ExtractFilePath(Application.ExeName),'syliascript.syl');
  FString1:=Format('/s"%s" /x /r',[FString3]);

  Full1.Clear;
  Full1.Add(Format('"%s" %s',[FString2,FString1]));
  MyShellExecute(FString2,FString1);
  if GetOption4=0 then begin
    RemoveFile(SlashSep(FBeta3,'MOVIE_1.AVI'));
  end;

  FString2:=SlashSep(ExtractFilePath(Application.ExeName),'VirtualDub.exe');
  FString3:=SlashSep(ExtractFilePath(Application.ExeName),'syliascript2.syl');
  FString1:=Format('/s"%s" /x /r',[(FString3)]);

  Full1.Add(Format('"%s" %s',[FString2,FString1]));
//  FString1:=SlashSep(ExtractFilePath(Application.ExeName),'SIM.BAT');
//  Full1.SaveToFile(FString1);

//  Wait(Hour1,2000);
  MyShellExecute(FString2,FString1);

//  MyShellExecute(FString1,'');

//  ShellExecute(0,'open',PChar(FString2),PChar(FString1),'',SW_SHOW);
  if GetOption4=0 then begin
    RemoveFile(SlashSep(FBeta3,'MOVIE0.AVI'));
    RemoveFile(FBeta2);
  end;
  Close;
end;

procedure TMyUMultipler.AddToCommande(FFull:TFull;FBeta1,FBeta2,FBeta3:String);
var
  FString1:String;
  FString2:String;
  FString3:String;
  XRandom:Integer;
begin
  XRandom:=0;
  while FileExists(SlashSep(GetPath,Format('syliascript%d-2.syl',[XRandom]))) do begin
    Inc(XRandom);
  end;
  Full1.Clear;
  Full1.Add(Format('VirtualDub.Open("%s",1,0);',[AssignSlash(FBeta1)]));
  Full1.Add(Format('VirtualDub.audio.SetSource("%s");',[AssignSlash(FBeta2)]));
  Full1.Add('VirtualDub.video.SetMode(0);');
  Full1.Add('VirtualDub.audio.SetMode(1);');
  Full1.Add('VirtualDub.audio.SetClipMode(1,0);');
  Full1.Add('VirtualDub.audio.SetConversion(44100,0,0,0,1);');
  Full1.Add('VirtualDub.audio.SetCompression(353,44100,2,16,8010,372,10,"AAgAAAEAdAEAAAE=");');

  Full1.Add(Format('VirtualDub.SaveAVI("%s");',[AssignSlash(SlashSep(FBeta3,'Movie0.avi'))]));
  Full1.Add('VirtualDub.Close();');
  Full1.SaveToFile(SlashSep(GetPath,Format('syliascript%d-1.syl',[XRandom])));

  Full1.Clear;
  Full1.Add(Format('VirtualDub.Open("%s",1,0);',[AssignSlash(SlashSep(FBeta3,'Movie0.avi'))]));
  Full1.Add('VirtualDub.audio.SetSource(1);');
  Full1.Add('VirtualDub.audio.SetMode(0);');
  Full1.Add('VirtualDub.audio.SetClipMode(1,1);');
  Full1.Add('VirtualDub.video.SetMode(0);');
  Full1.Add('VirtualDub.video.SetFrameRate(-1,1);');
  Full1.Add(Format('VirtualDub.SaveAVI("%s");',[AssignSlash(SlashSep(FBeta3,'FILM.AVI'))]));
  Full1.Add('VirtualDub.Close();');
  Full1.SaveToFile(SlashSep(GetPath,Format('syliascript%d-2.syl',[XRandom])));

  FString2:=SlashSep(GetPath,'VirtualDub.exe');
  FString3:=SlashSep(GetPath,Format('syliascript%d-1.syl',[XRandom]));
  FString1:=Format('/s"%s" /x /r',[FString3]);

  Full1.Clear;
  Full1.Add(Format('"%s" %s',[FString2,FString1]));

  FFull.Add(Format('"%s" %s',[FString2,FString1]));
//  MyShellExecute(FString2,FString1);

  FString2:=SlashSep(GetPath,'VirtualDub.exe');
  FString3:=SlashSep(GetPath,Format('syliascript%d-2.syl',[XRandom]));
  FString1:=Format('/s"%s" /x /r',[(FString3)]);

  Full1.Add(Format('"%s" %s',[FString2,FString1]));
//  FString1:=SlashSep(ExtractFilePath(Application.ExeName),'SIM.BAT');
//  Full1.SaveToFile(FString1);

  FFull.Add(Format('"%s" %s',[FString2,FString1]));

//  Wait(Hour1,2000);
//  MyShellExecute(FString2,FString1);

//  MyShellExecute(FString1,'');

//  ShellExecute(0,'open',PChar(FString2),PChar(FString1),'',SW_SHOW);
end;


procedure TMyUMultipler.SpeedButton1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMyUMultipler.SpeedButton2Click(Sender: TObject);
begin
  if not OpenDialog2.Execute then Exit;
  Edit2.Text:=OpenDialog2.FileName;
end;

procedure TMyUMultipler.SpeedButton3Click(Sender: TObject);
begin
  if not FolderBrowse1.Execute then Exit;
  Edit3.Text:=FolderBrowse1.Directory;
end;

procedure TMyUMultipler.FormShow(Sender: TObject);
begin
  Feed;
  Edit1.Text:='';
  Edit2.Text:='';
  Edit3.Text:='';
  ComboBox7.ItemIndex:=0;
end;

function TMyUMultipler.AssignSlash(FString:String):String;
var
  i1:Integer;
  FType:String;
begin
  FType:='';
  for i1:=1 to Length(FString) do begin
    FType:=FType+Copy(FString,i1,1);
    if Copy(FString,i1,1)='\' then FType:=FType+'\';
  end;
  Result:=FType;
//  ShowMessage(Format('[%s][%s]',[FString,FType]));
end;

procedure TMyUMultipler.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To Multiplexing a video and audio...';
      Panel2.Caption:='Select the video File';
      Panel4.Caption:='Select the audio File';
      Panel9.Caption:='Select the audio Type';
      Panel7.Caption:='Select the output Directory';
      BitBtn5.Caption:='Multiplex';
      BitBtn6.Caption:='Cancel';
    end;
    1:begin
      Caption:='Pour mixer la vido et l''audio...';
      Panel2.Caption:='Selectionner le fichier vido';
      Panel4.Caption:='Selectionner le fichier audio';
      Panel9.Caption:='Selectionner le type d''audio';
      Panel7.Caption:='Selectionner le rpertoire de sortie';
      BitBtn5.Caption:='Mixer';
      BitBtn6.Caption:='Arrter';
    end;
  end;
end;


end.
