unit UOption;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UFonction, StdCtrls, Buttons, ExtCtrls, Demande;

type
  TMyUOption = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    RadioGroup2: TRadioGroup;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Demande1: TDemande;
    GroupBox2: TGroupBox;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    GroupBox3: TGroupBox;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    GroupBox4: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    GroupBox5: TGroupBox;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    GroupBox6: TGroupBox;
    CheckBox6: TCheckBox;
    GroupBox7: TGroupBox;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Feed;
  end;

var
  MyUOption: TMyUOption;

implementation

uses UMain;

{$R *.DFM}

procedure TMyUOption.FormShow(Sender: TObject);
begin
  Feed;
  if GetOption1=0 then RadioButton1.Checked:=True
  else RadioButton2.Checked:=True;
  if GetOption2=0 then RadioButton3.Checked:=True
  else RadioButton4.Checked:=True;
  if GetOption3=0 then RadioButton5.Checked:=True
  else RadioButton6.Checked:=True;
  if GetOption4=0 then RadioButton7.Checked:=True
  else RadioButton8.Checked:=True;
  if GetOption5.Encode=0 then CheckBox1.Checked:=False
  else CheckBox1.Checked:=True;
  if GetOption5.Batch=0 then CheckBox2.Checked:=False
  else CheckBox2.Checked:=True;
  if GetOption5.Command=0 then CheckBox3.Checked:=False
  else CheckBox3.Checked:=True;
  if GetOption6=1 then RadioButton9.Checked:=True
  else RadioButton10.Checked:=True;
  if GetOption7=1 then CheckBox6.Checked:=True
  else CheckBox6.Checked:=False;
  if GetOption8=0 then RadioButton11.Checked:=True
  else RadioButton12.Checked:=True;
end;

procedure TMyUOption.BitBtn1Click(Sender: TObject);
var
  AShutDown:TShutDown;
  AOption:Integer;
begin
  if RadioButton1.Checked then SetOption1(0)
  else SetOption1(1);
  if RadioButton3.Checked then SetOption2(0)
  else SetOption2(1);
  if RadioButton5.Checked then SetOption3(0)
  else SetOption3(1);
  if RadioButton7.Checked then SetOption4(0)
  else SetOption4(1);
  if CheckBox1.Checked then AShutDown.Encode:=1
  else AShutDown.Encode:=0;
  if CheckBox2.Checked then AShutDown.Batch:=1
  else AShutDown.Batch:=0;
  if CheckBox3.Checked then AShutDown.Command:=1
  else AShutDown.Command:=0;
  SetOption5(AShutDown);
  if RadioButton9.Checked then SetOption6(1)
  else SetOption6(0);
  if CheckBox6.Checked then SetOption7(1)
  else SetOption7(0);
  AOption:=-1;
  if RadioButton11.Checked then AOption:=0
  else AOption:=1;
  if AOption<>GetOption8 then begin
    with Demande1 do begin
      case GetOption2 of
        0:begin
          Msg:='Be sure that you install the codec in codec directory!'+#13+
               'And remember that Beta Codec (4.0) is only in test now!'+#13+
               'The best one is still the 3.11!';
          ShowModal;
        end;
        1:begin
          Msg:='Soyez sur d''avoir installer tous les codecs dans les rpertoire codec!'+#13+
               'et souvenez-vous que la version Beta 40 est en test et que'+#13+
               'la meilleur reste la version 3.11!';
          ShowModal;
        end;
      end;
    end;
  end;
  SetOption8(AOption);
  MyUMain.Feed;
  Close;
end;

procedure TMyUOption.Feed;
begin
  case GetOption2 of
    0:begin
      RadioButton2.Caption:='Expert Mode';
      RadioButton1.Caption:='Standard Mode';
      RadioGroup2.Caption:='Language';
      RadioButton3.Caption:='English version';
      RadioButton4.Caption:='French Version';
      GroupBox2.Caption:=' CD Size ';
      GroupBox3.Caption:=' Erase Temp File ? ';
      RadioButton7.Caption:='Yes';
      RadioButton8.Caption:='No';
      CheckBox1.Caption:='After Encode';
      CheckBox2.Caption:='After Batch Command';
      CheckBox3.Caption:='After Batch File';
      GroupBox4.Caption:=' ShutDown ';
      GroupBox5.Caption:=' Automaticaly cut double AVI ';
      RadioButton9.Caption:=' Yes ';
      RadioButton10.Caption:=' No ';
      GroupBox6.Caption:=' Erase VOB file direct after encoding ? ';
      CheckBox6.Caption:='Yes, DO it!';
      GroupBox7.Caption:=' Codec Selector ';
      RadioButton11.Caption:=' 3.11 ALPHA CODEC ';
      RadioButton12.Caption:=' 4.0 BETA CODEC';
    end;
    1:begin
      RadioButton2.Caption:='Mode Expert';
      RadioButton1.Caption:='Mode Standard';
      RadioGroup2.Caption:='Language';
      RadioButton3.Caption:='Version Anglaise';
      RadioButton4.Caption:='Version franaise';
      GroupBox2.Caption:=' Taille CD ';
      GroupBox3.Caption:=' Effacer Fichier Temporaire? ';
      RadioButton7.Caption:='Oui';
      RadioButton8.Caption:='Non';
      CheckBox1.Caption:='Aprs Encoder';
      CheckBox2.Caption:='Aprs Crer Tout';
      CheckBox3.Caption:='Aprs Fichier Batch';
      GroupBox4.Caption:=' Fermeture de Windows ';
      GroupBox5.Caption:=' Automatiquement couper les AVI doubles ';
      RadioButton9.Caption:=' Oui ';
      RadioButton10.Caption:=' Non ';
      GroupBox6.Caption:='Effacer automatique les VOB aprs encodage ';
      CheckBox6.Caption:='Oui, fais-le!';
      GroupBox7.Caption:=' Selecteur de Codec ';
      RadioButton11.Caption:=' 3.11 ALPHA CODEC ';
      RadioButton12.Caption:=' 4.0 BETA CODEC';
    end;
  end;
end;

end.
