unit UCutting;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Hour, FolderBrowse, Full, Demande, StdCtrls, Buttons,
  MySource,UFonction, Mask,FileCtrl,vfw, AviCutting;

type
  TMyUCutting = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel5: TPanel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Panel6: TPanel;
    SpeedButton3: TSpeedButton;
    Panel7: TPanel;
    Edit3: TEdit;
    Demande1: TDemande;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    Full1: TFull;
    FolderBrowse1: TFolderBrowse;
    Hour1: THour;
    AviCutting1: TAviCutting;
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Feed;
    procedure DoWork;
    procedure MyDoShow;
    procedure MyDoHide;
  end;

var
  MyUCutting: TMyUCutting;

implementation

{$R *.DFM}

procedure TMyUCutting.FormShow(Sender: TObject);
begin
  MyDoShow;
  Feed;
  Edit1.Text:='';
  Edit3.Text:='';
end;

procedure TMyUCutting.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To Cut an AVI';
      Panel2.Caption:='Select the AVI';
      Panel7.Caption:='Select the output Directory';
      BitBtn5.Caption:='Cut!';
      BitBtn6.Caption:='Cancel';
    end;
    1:begin
      Caption:='Pour Couper un AVI';
      Panel2.Caption:='Selectionner l''AVI';
      Panel7.Caption:='Selectionner le rpertoire de sortie';
      BitBtn5.Caption:='Couper!';
      BitBtn6.Caption:='Arrter';
    end;
  end;
end;

procedure TMyUCutting.SpeedButton1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMyUCutting.SpeedButton3Click(Sender: TObject);
begin
  if not FolderBrowse1.Execute then Exit;
  Edit3.Text:=FolderBrowse1.Directory;
end;

procedure TMyUCutting.BitBtn5Click(Sender: TObject);
var
  ACount1,ACount2:Integer;
begin
  with Demande1 do begin
    if (Edit1.Text='') or (not FileExists(Edit1.Text)) then begin
      if GetOption2=0 then Msg:='You must select an avi before processing!'
      else Msg:='Vous devez slectionner le fichier AVI avant de continuer!';
      ShowModal;
      Exit;
    end;
    if not DirectoryExists(Edit3.Text) then begin
      if GetOption2=0 then Msg:='The output directory doesn''t exists!'
      else Msg:='Le rpertoire de sortie n''existe pas!';
      ShowModal;
      Exit;
    end;
  end;
  DoWork;
  Close;
end;

procedure TMyUCutting.DoWork;
var
  AInfo:TKFInfo;
  ATemp5,ATemp4,ATemp1,ATemp2,ATemp3:String;
begin
  MyDoHide;
  with AviCutting1 do begin
    FileName:=Edit1.Text;
    if not Execute then begin
      with Demande1 do begin
        if GetOption2=0 then begin
          Msg:='Impossible to work with the AVI!';
        end
        else begin
          Msg:='Impossible d''ouvrir l''AVI!';
        end;
        ShowModal;
        Exit;
      end;
    end;
    AInfo:=GetNearKF(TotalFrame div 2);
    if (AInfo.First=-1) or (AInfo.Second=-1) then begin
      with Demande1 do begin
        if GetOption2=0 then begin
          Msg:='Impossible to work with the AVI!';
        end
        else begin
          Msg:='Impossible d''ouvrir l''AVI!';
        end;
        ShowModal;
        Exit;
      end;
    end;
    ATemp1:=ExtractFilePath(Edit1.Text);
    ATemp2:=ExtractFileName(Edit1.Text);
    ATemp5:=ChangeFileExt(ATemp2,'');
    ATemp2:=ATemp5;
    ATemp3:=SlashSep(ATemp1,Format('%s1.AVI',[ATemp2]));
    ATemp4:=SlashSep(ATemp1,Format('%s2.AVI',[ATemp2]));
    CreateSyl(Edit1.Text,ATemp3,ATemp4,SlashSep(GetPath,'TEMP1.SYL'),
              SlashSep(GetPath,'TEMP2.SYL'),AInfo);
    ExecuteSyl(GetPath);
  end;
end;

procedure TMyUCutting.MyDoShow;
begin
  SpeedButton1.Enabled:=True;
  SpeedButton3.Enabled:=True;
  BitBtn5.Enabled:=True;
  BitBtn6.Enabled:=True;
end;

procedure TMyUCutting.MyDoHide;
begin
  SpeedButton1.Enabled:=False;
  SpeedButton3.Enabled:=False;
  BitBtn5.Enabled:=False;
  BitBtn6.Enabled:=False;
end;

end.
