unit UIfoRead;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, IfoInfo, Demande,UFonction;

type
  TMyUIfoRead = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Panel3: TPanel;
    Panel4: TPanel;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    IfoInfo1: TIfoInfo;
    Demande1: TDemande;
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DoClear;
    procedure Feed;
  end;

var
  MyUIfoRead: TMyUIfoRead;

implementation

{$R *.DFM}

procedure TMyUIfoRead.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then begin
    Close;
    Exit;
  end;
end;

procedure TMyUIfoRead.FormShow(Sender: TObject);
begin
  Feed;
  DoClear;
end;

procedure TMyUIfoRead.DoClear;
begin
  Edit1.Text:='';
  ListBox1.Items.Clear;
  Panel4.Caption:='';
end;

procedure TMyUIfoRead.SpeedButton1Click(Sender: TObject);
var
  i1:Integer;
begin
  if not OpenDialog1.Execute then Exit;
  DoClear;
  Edit1.Text:=OpenDialog1.FileName;
  with IfoInfo1 do begin
    FileName:=Edit1.Text;
    if not Execute then begin
      with Demande1 do begin
        if GetOption2=0 then
          Msg:='A error occured when reading the IFO file!'
        else
          Msg:='Une Erreur s''est produite dans la lecture du fichier IFO!';
        ShowModal;
      end;
      DoClear;
      Exit;
    end;
    Panel4.Caption:=FileLength;
    for i1:=0 to AudioList.Count-1 do begin
      ListBox1.Items.Add(AudioList.Strings[i1]);
    end;
  end;
end;

procedure TMyUIFORead.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To Read IFO File';
      Panel2.Caption:='Select the IFO file';
      BitBtn1.Caption:='Exit';
    end;
    1:begin
      Caption:='Pour Lire un Fichier IFO';
      Panel2.Caption:='Selectionner le fichier IFO';
      BitBtn1.Caption:='Quitter';
    end;
  end;
end;

end.
