unit UNormaliser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Demande, StdCtrls, Buttons, ExtCtrls,ShellApi,MySource,UFonction,Full,
  Advgauge, DosOutPut, ComCtrls;

type
  TMyUNormaliser = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    Demande1: TDemande;
    OuputDos1: TOuputDos;
    Panel4: TPanel;
    AdvGauge1: TAdvGauge;
    Timer1: TTimer;
    OuputDos2: TOuputDos;
    Panel3: TPanel;
    Edit2: TEdit;
    UpDown1: TUpDown;
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OuputDos1Data(Sender: TOuputDos; Buffer: Pointer;
      Size: Integer);
    procedure OuputDos1ErrorData(Sender: TOuputDos; Buffer: Pointer;
      Size: Integer);
    procedure OuputDos1Terminated(Sender: TObject);
    procedure OuputDos2Data(Sender: TOuputDos; Buffer: Pointer;
      Size: Integer);
    procedure OuputDos2ErrorData(Sender: TOuputDos; Buffer: Pointer;
      Size: Integer);
    procedure OuputDos2Terminated(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDown1ChangingEx(Sender: TObject; var AllowChange: Boolean;
      NewValue: Smallint; Direction: TUpDownDirection);
  private
    { Private declarations }
  public
    { Public declarations }
    CommandLine2:String;
    ABetaLine1,ABetaLine2:String;
    AFirst:Boolean;
    ACommand:Boolean;
    ASize:Integer;
    ASipe:Double;
    FIsCommand:Boolean;
  public
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure MyCommande(FString:String;FFrom:Boolean=False);
    procedure MyCommande2;
    procedure AddToCommande(FFull:TFull;FString:String);
    procedure GetSubLine(FString:String);
    function TreadPath(FString:String):String;
    procedure Feed;
  end;

var
  MyUNormaliser: TMyUNormaliser;

implementation

{$R *.DFM}

constructor TMyUNormaliser.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
end;

destructor TMyUNormaliser.Destroy;
begin
  inherited Destroy;
end;

procedure TMyUNormaliser.SpeedButton1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMyUNormaliser.BitBtn1Click(Sender: TObject);
begin
  if not FileExists(Edit1.Text) then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Please select a file before going on...!'
      else Msg:='SVP, Slectionnez un fichier avant de continuer...';
      ShowModal;
      Exit;
    end;
  end;
  MyCommande(Edit1.Text,True);
end;

procedure TMyUNormaliser.MyCommande(FString:String;FFrom:Boolean);
var
  FString1,FString2:String;
  CommandLine:String;
begin
  Panel1.Cursor:=crHourGlass;
  Panel2.Cursor:=crHourGlass;
  Panel3.Cursor:=crHourGlass;
  Panel4.Cursor:=crHourGlass;
{  Panel5.Cursor:=crHourGlass;}
  AdvGauge1.Cursor:=crHourGlass;
  Edit1.Cursor:=crHourGlass;
  Edit2.Cursor:=crHourGlass;
  UpDown1.Cursor:=crHourGlass;
  Cursor:=crHourGlass;
  FIsCommand:=True;
  TreadPath(FString);
  if not FFrom then begin
    BitBtn1.Enabled:=False;
    BitBtn2.Enabled:=False;
    Show;
    SpeedButton1.Enabled:=False;
    Application.ProcessMessages;
  end;
  AdvGauge1.Prepare(0,100,1);
  AdvGauge1.Prepare(0,100,2);
  BitBtn1.Enabled:=False;
  SpeedButton1.Enabled:=False;
  ASipe:=UpDown1.Position/100;
  FString1:=Format('-l %.2f %s',[ASipe,FString]);
  FString2:=SlashSep(ExtractFilePath(Application.ExeName),'Normalize.exe');
{  Panel5.Caption:='';}
  with OuputDos1 do begin
    Prepare;
    CommandLine:=Format('%s %s',[FString2,FString]);
    CommandLine2:=Format('%s %s',[FString2,FString1]);
    Execute;
  end;
end;

procedure TMyUNormaliser.MyCommande2;
begin
  with OuputDos2 do begin
    Prepare;
    CommandLine:=CommandLine2;
    Execute;
  end;
end;

procedure TMyUNormaliser.AddToCommande(FFull:TFull;FString:String);
var
  FString1,FString2:String;
begin
  FString1:=Format('-l 1.88 %s',[FString]);
  FString2:=SlashSep(ExtractFilePath(Application.ExeName),'Normalize.exe');
  FFull.Add(Format('"%s" %s',[FString2,FString]));
  FFull.Add(Format('"%s" %s',[FString2,FString1]));
end;


procedure TMyUNormaliser.FormShow(Sender: TObject);
begin
  Panel1.Cursor:=crDefault;
  Panel2.Cursor:=crDefault;
  Panel3.Cursor:=crDefault;
  Panel4.Cursor:=crDefault;
{  Panel5.Cursor:=crHourGlass;}
  AdvGauge1.Cursor:=crDefault;
  Edit1.Cursor:=crDefault;
  Edit2.Cursor:=crDefault;
  UpDown1.Cursor:=crDefault;
  Cursor:=crDefault;
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=True;
  if not ACommand then FIsCommand:=False
  else FIsCommand:=True;
  Feed;
  if not ACommand then UpDown1.Position:=188;
  AFirst:=False;
  Edit1.Text:='';
  AdvGauge1.Prepare(0,100,1);
  AdvGauge1.Prepare(0,100,2);
{  Panel5.Caption:='';}
  BitBtn1.Enabled:=True;
  SpeedButton1.Enabled:=True;
  AFirst:=True;
end;

procedure TMyUNormaliser.OuputDos1Data(Sender: TOuputDos; Buffer: Pointer;
  Size: Integer);
begin
  if Length(OuputDos1.GetLine(Buffer,Size))>0 then begin
{    Panel5.Caption:=OuputDos1.GetLine(Buffer,Size);}
  end;
{  GetSubLine(Panel5.Caption);}
  Application.ProcessMessages;
end;

procedure TMyUNormaliser.OuputDos1ErrorData(Sender: TOuputDos;
  Buffer: Pointer; Size: Integer);
begin
  if Length(OuputDos1.GetLine(Buffer,Size))<>0 then begin
{    Panel5.Caption:=OuputDos1.GetLine(Buffer,Size);}
  end;
{  GetSubLine(Panel5.Caption);}
  Application.ProcessMessages;
end;

procedure TMyUNormaliser.OuputDos1Terminated(Sender: TObject);
begin
  if OuputDos1.Running then OuputDos1.Terminate(0);
{  Panel5.Caption:='First Work over...';}
//  AdvGauge1.MoveTo(50);
  MyCommande2;
end;



procedure TMyUNormaliser.OuputDos2Data(Sender: TOuputDos; Buffer: Pointer;
  Size: Integer);
begin
{  Panel5.Caption:=OuputDos1.GetLine(Buffer,Size);}
  Application.ProcessMessages;
end;

procedure TMyUNormaliser.OuputDos2ErrorData(Sender: TOuputDos;
  Buffer: Pointer; Size: Integer);
begin
{  Panel5.Caption:=OuputDos1.GetLine(Buffer,Size);}
  Application.ProcessMessages;
end;

procedure TMyUNormaliser.OuputDos2Terminated(Sender: TObject);
begin
  if OuputDos2.Running then OuputDos2.Terminate(0);
  Close;
end;

procedure TMyUNormaliser.BitBtn2Click(Sender: TObject);
begin
  if OuputDos1.Running then OuputDos1.Terminate(0);
  if OuputDos2.Running then OuputDos2.Terminate(0);
  Close;
end;

procedure TMyUNormaliser.GetSubLine(FString:String);
begin
  if AnsiPos('%',FString)<>0 then begin
  end;
end;

procedure TMyUNormaliser.Timer1Timer(Sender: TObject);
var
  AFile,AFileLength:Integer;
  ANumber1,ANumber2:Integer;
begin
{  case GetOption2 of
    0:Panel5.Caption:='This is not the real state. Just to show that we are not dead!';
    1:Panel5.Caption:='Ce n''est pas le bon tat. Juste pour montrer que tout va bien!';
  end;}
  if not FIsCommand then Exit;
  ANumber1:=Random(101);
  ANumber2:=Random(101);
  AdvGauge1.MoveTo(ANumber1,1);
  AdvGauge1.MoveTo(ANumber2,2);
  if not AFirst then Exit;
  if not ACommand then Exit;
  AFirst:=False;
  case GetOption2 of
    0:begin
      Caption:='Please Don''t cut me!!!!!! I''m Working';
    end;
    1:begin
      Caption:='SVP. Ne me coupez pas!!!! Je travaille!!!';
    end;
  end;
  MyCommande(ABetaLine1);
end;


procedure TMyUNormaliser.FormCreate(Sender: TObject);
begin
  ACommand:=False;
end;

function TMyUNormaliser.TreadPath(FString:String):String;
begin
  Result:=ExtractShortPathName(FString);
end;

procedure TMyUNormaliser.UpDown1ChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint;
  Direction: TUpDownDirection);
begin
  Edit2.Text:=DToS(NewValue/100);
end;

procedure TMyUNormaliser.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To Normalize a WAV';
      Panel2.Caption:='Select the file to Normalize.';
      BitBtn1.Caption:='Normalize';
      BitBtn2.Caption:='Cancel';
    end;
    1:begin
      Caption:='Pour Normaliser un WAV';
      Panel2.Caption:='Selectionner le fichier  normaliser.';
      BitBtn1.Caption:='Normaliser';
      BitBtn2.Caption:='Arrter';
    end;
  end;
end;

end.
